#!/usr/bin/perl

# Copyright Platform Computing Inc., an IBM company, 2012

$util = 1;
# A bit of extra work to find MPI_ROOT:
#   - val from config.sh will be first choice
#   - if not there somehow, current env is second choice
#   - else try the standard location
if ( -f "../config.sh" ) {
  $root = `. ../config.sh ; echo \$MPI_ROOT`;
  chomp $root;
}
if ( ! -f "$root/bin/mkreport.pl" ) {
  $root = $ENV{'MPI_ROOT'};
}
if ( ! -f "$root/bin/mkreport.pl" ) {
  $root = "/opt/ibm/platform_mpi";
}
if ( ! -f "$root/bin/mkreport.pl" ) {
  print "Failure finding \$MPI_ROOT/bin/mkreport.pl - try setting MPI_ROOT\n";
  exit(1);
}
do "$root/bin/mkreport.pl";

sub cleanup_files_otherthan {
  my @argv = @{shift @_};
  my @goodfiles = @_;
  my $file;
  my $goodfile;
  my $isgood;
  my $erase;
  my $arg;

  $erase = 0;
  for $arg (@argv) {
    if ($arg eq "-rm") {
      $erase = 1;
    }
  }
  if ($erase) {
    print "ERASING extra files:\n";
  } else {
    print "Listing extra files (use -rm to auto-erase):\n";
  }

  opendir UTILDIR, ".";
  while ($file = readdir UTILDIR) {
    if (! ($file =~ /[A-Za-z0-9]/)) { next; } # Just for safety

    $isgood = 0;
    for $goodfile (@goodfiles) {
      if ($file eq $goodfile) {
        $isgood = 1;
      }
    }
    if (! $isgood) {
      print "  $file\n";
      if ($erase) { system "rm -rf $file"; }
    }
  }
  closedir UTILDIR;
}
sub rmfiles_thatmatch {
  my @patterns = @_;
  my $file;
  my $pattern;
  my $ismatch;

  opendir UTILDIR, ".";
  while ($file = readdir UTILDIR) {
    if (! ($file =~ /[A-Za-z0-9]/)) { next; } # Just for safety

    $ismatch = 0;
    for $pattern (@patterns) {
      if ($file =~ /^$pattern$/) {
        $ismatch = 1;
      }
    }
    if ($ismatch) {
      print "Erasing $file\n";
      system "rm -rf $file";
    }
  }
  closedir UTILDIR;
}
